/*
 * Embed the rcs id of a source file in the resulting library.  Note that in
 * more recent ELF binutils, we use .ident allowing the ID to be stripped.
 * Usage:
 *      __FBSDID("$FreeBSD: src/sys/sys/cdefs.h,v 1.93.2.2 2008/04/25 16:59:30 sam Exp $");
 */

#include <sys/appleapiopts.h>
#include <sys/_types.h>
#include <netinet/in.h>
#include <stdint.h>

#ifndef __FBSDID
#if !defined(lint) && !defined(STRIP_FBSDID)
#define __FBSDID(s)     __IDSTRING(__CONCAT(__rcsid_,__LINE__),s)
#else
#define __FBSDID(s)     struct __hack
#endif
#endif

#ifndef __DECONST
#define __DECONST(type, var)    ((type)(uintptr_t)(const void *)(var))
#endif

#ifndef STDERR_FILENO
#define STDERR_FILENO 2
#endif

#ifndef STDIN_FILENO
#define STDIN_FILENO 0
#endif

#ifndef _PATH_AUTHCONF
#define _PATH_AUTHCONF  "/etc/auth.conf"
#endif

#ifndef _PATH_ETC
#define	_PATH_ETC	"/etc"
#endif

#ifndef PATH_MAX
#define	PATH_MAX		 1024
#endif

#ifndef KERN_PROC_VMMAP
#define	KERN_PROC_VMMAP		32
#endif

typedef	unsigned int __dev_t;
typedef	unsigned int	lwpid_t;

#ifndef KERN_PROC_FILEDESC
#define	KERN_PROC_FILEDESC	33
#endif

#ifndef RLIMIT_SBSIZE
#define	RLIMIT_SBSIZE	9
#endif

#ifndef RLIMIT_VMEM
#define RLIMIT_VMEM	10
#endif

#ifndef EDOOFUS
#define EDOOFUS		88
#endif

#ifndef FILENAME_MAX
#define	FILENAME_MAX	1024
#endif

#ifndef no_argument        0
#define no_argument        0
#endif

#ifndef required_argument
#define required_argument  1
#endif

struct kinfo_file {
	int	kf_structsize;			/* Variable size of record. */
	int	kf_type;			/* Descriptor type. */
	int	kf_fd;				/* Array index. */
	int	kf_ref_count;			/* Reference count. */
	int	kf_flags;			/* Flags. */
	int	_kf_pad0;			/* Round to 64 bit alignment */
	int64_t	kf_offset;			/* Seek location. */
	int	kf_vnode_type;			/* Vnode type. */
	int	kf_sock_domain;			/* Socket domain. */
	int	kf_sock_type;			/* Socket type. */
	int	kf_sock_protocol;		/* Socket protocol. */
	struct sockaddr_storage kf_sa_local;	/* Socket address. */
	struct sockaddr_storage	kf_sa_peer;	/* Peer address. */
	int	_kf_ispare[16];			/* Space for more stuff. */
	/* Truncated before copyout in sysctl */
	char	kf_path[PATH_MAX];		/* Path to file, if any. */
};

struct kinfo_vmentry {
        int      kve_structsize;                /* Variable size of record. */
        int      kve_type;                      /* Type of map entry. */
        uint64_t kve_start;                     /* Starting address. */
        uint64_t kve_end;                       /* Finishing address. */
        uint64_t kve_offset;                    /* Mapping offset in object */
        uint64_t kve_fileid;                    /* inode number if vnode */
        uint32_t kve_fsid;                      /* dev_t of vnode location */
        int      kve_flags;                     /* Flags on map entry. */
        int      kve_resident;                  /* Number of resident pages. */
        int      kve_private_resident;          /* Number of private pages. */
        int      kve_protection;                /* Protection bitmask. */
        int      kve_ref_count;                 /* VM obj ref count. */
        int      kve_shadow_count;              /* VM obj shadow count. */
        int      _kve_pad0;                     /* 64bit align next field */
        int      _kve_ispare[16];               /* Space for more stuff. */
        /* Truncated before copyout in sysctl */
        char     kve_path[PATH_MAX];            /* Path to VM obj, if any. */
};

int	 symlink(const char *, const char *);
int	 isatty(int);
unsigned int
         alarm(unsigned int);

int	 mkstemps(char *, int);
int      getopt(int, char * const [], const char *) __DARWIN_ALIAS(getopt);
extern char *optarg;                    /* getopt(3) external variables */
extern int optind, opterr, optopt;
int	 unlink(const char *);
int	 chown(const char *, uid_t, gid_t);
pid_t	 getpgrp(void);
pid_t	 getpid(void);
unsigned int
         sleep(unsigned int) __DARWIN_ALIAS_C(sleep);
